import GameLogic as gl
from math import pi
from  mathutils import Euler

def obj_orientation(obj, alpha, beta, gamma):
    '''Set obj orientation with angle in degrees'''
    alpha = alpha*pi/180
    beta = beta*pi/180
    gamma = gamma*pi/180
    rot_in_euler = Euler([alpha,beta,gamma])
    obj.worldOrientation = rot_in_euler.to_matrix()

# Get controller and owner
controller = gl.getCurrentController()
owner = controller.owner
# owner is head
# Get obj
scene = gl.getCurrentScene()
objList = scene.objects
mouth = objList["Mouth"]
eye_l = objList["Eye_left"]
eye_r = objList["Eye_right"]
eyebrow_left = objList["Eyebrow_left"]
eyebrow_right = objList["Eyebrow_right"]
jaw = objList["Jaw"]
nostrils = objList["Nostrils"]

# Get
attribution = gl.attribution

# Get data in gl
for key, value in attribution.items():
    getattr(gl, value)

# Set ower = head
owner.worldPosition=(5-gl.pose_position[0]/60, 0, 6-gl.pose_position[1]/30)
alpha = gl.pose_orientation[0]*90
beta = -gl.pose_orientation[2]*90
gamma = gl.pose_orientation[1]*90
obj_orientation(owner, alpha, beta, gamma)
owner.localScale = (gl.pose_scale, gl.pose_scale, gl.pose_scale)

# Set mouth
mouth.localScale = (gl.mouth_width/15, 1, 0.8+gl.mouth_height/5)

# Set Eye
eye_l.localScale = (-0.3+gl.eye_left/2, -0.3+gl.eye_left/2, -0.3+gl.eye_left/2)
eye_r.localScale = (-0.3+gl.eye_right/2, -0.3+gl.eye_right/2, -0.3+gl.eye_right/2)

# Set Eyebrow
eb_l_pos = eyebrow_left.localPosition
eyebrow_left.localPosition=(eb_l_pos[0], eb_l_pos[1], 0.1+gl.eyebrow_left/10)

eb_r_pos = eyebrow_right.localPosition
eyebrow_right.localPosition=(eb_r_pos[0], eb_r_pos[1], 0.1+gl.eyebrow_right/10)

# Set Nostril
nostrils_pos = nostrils.localPosition
nostrils.localPosition = (nostrils_pos[0], nostrils_pos[1], -0.5+gl.nostrils/10)

# Set Jaw
jaw_pos = jaw.localPosition
jaw.localPosition = (jaw_pos[0], jaw_pos[1], 1.1-gl.jaw/10)

