import GameLogic as gl
import socket
import OSC

# Get controller and owner
controller = gl.getCurrentController()
owner = controller.owner

# Set init
ip = '127.0.0.1'
port_1 = 8338
buffer_size = 1024

# Get
attribution = gl.attribution
raw_data_1 = 0
data_1 = []

# Connect Blender on socket 1
if not owner['connected_1']:
    owner['connected_1'] = True
    gl.socket_1 = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
    gl.socket_1.bind((ip, port_1))
    gl.socket_1.setblocking(0)
    gl.socket_1.settimeout(0.01)
    # Set Buffer size
    # gl.socket_1.setsockopt(level, optname, value)
    gl.socket_1.setsockopt(socket.SOL_SOCKET, socket.SO_RCVBUF, buffer_size)

# If Blender connected_1
else:
    try:
        raw_data_1, port_1 = gl.socket_1.recvfrom(buffer_size)
        data_1 = OSC.decodeOSC(raw_data_1)
    except socket.error:
        pass

# Set data in gl
data_1 = data_1[2:]
for i in range(len(data_1)):
    for key, value in attribution.items():
        if data_1[i][0]==key:
            setattr(gl, value, data_1[i][2])
        if data_1[i][0]=='/pose/position' :
            setattr(gl, 'pose_position', [data_1[i][2],data_1[i][3]])
        if  data_1[i][0]=='/pose/orientation':
            setattr(gl, 'pose_orientation',
            [data_1[i][2],data_1[i][3],data_1[i][4]])

# Print every 120 frames all variables and values to debug
tempo=gl.tempo
if gl.tempo == 120:
    gl.tempo = 0
    for key, value in attribution.items():
        print (value, ' = ', getattr(gl, value)),
    print()
gl.tempo += 1
